import { AsyncCallback, AsyncCb, BaseCallback, Callback, Cb, Context, GraphMode, NodeType, PartialConfig, PositionType, TraversalMode } from "./types";
declare class CallbacksBuilder<T extends BaseCallback, CbType extends Cb, TUpper extends BaseWalkBuilder<T, CbType>> {
    private cbs;
    private source;
    private readonly callback;
    constructor(cbs: CbType[], source: TUpper);
    withExecutionOrder(order: number): CallbacksBuilder<T, CbType, TUpper>;
    filteredByNodeTypes(...types: NodeType[]): CallbacksBuilder<T, CbType, TUpper>;
    filteredByKeys(...keys: string[]): CallbacksBuilder<T, CbType, TUpper>;
    filteredByPositions(...positions: PositionType[]): CallbacksBuilder<T, CbType, TUpper>;
    done(): TUpper;
}
declare abstract class BaseWalkBuilder<T extends BaseCallback, CbType extends Cb> {
    protected config: PartialConfig<T>;
    withConfig(config: PartialConfig<T>): this;
    withTraversalMode(traversalMode: TraversalMode): this;
    withGraphMode(graphMode: GraphMode): this;
    withRootObjectCallbacks(val: boolean): this;
    withRunningCallbacks(val: boolean): this;
    withConfiguredCallbacks(...callbacks: CbType[]): CallbacksBuilder<T, CbType, this>;
    withConfiguredCallback(callback: CbType): CallbacksBuilder<T, CbType, this>;
    withCallback(callback: T): this;
    withCallbacks(...callbacks: T[]): this;
}
export declare class WalkBuilder extends BaseWalkBuilder<Callback, Cb> {
    walk(obj: object): Context<Callback>;
    withSimpleCallback(callback: Cb): this;
    withSimpleCallbacks(...callbacks: Cb[]): this;
}
export declare class AsyncWalkBuilder extends BaseWalkBuilder<AsyncCallback, AsyncCb> {
    withParallelizeAsyncCallbacks(val: boolean): this;
    withSimpleCallback(callback: AsyncCb): this;
    withSimpleCallbacks(...callbacks: AsyncCb[]): this;
    walk(obj: object): Promise<Context<AsyncCallback>>;
}
export {};
